// VBConversions Note: VB project level imports
using System.Collections.Generic;
using System;
using System.Linq;
using System.Drawing;
using System.Diagnostics;
using System.Data;
using System.Xml.Linq;
using Microsoft.VisualBasic;
using System.Collections;
using System.Windows.Forms;
// End of VB project level imports

using System.Runtime.InteropServices;




namespace WindowsApplication1
{
    public partial class Form1
    {
        public Form1()
        {
            InitializeComponent();

            //Added to support default instance behavour in C#
            if (defaultInstance == null)
                defaultInstance = this;
        }

        #region Default Instance

        private static Form1 defaultInstance;

        /// <summary>
        /// Added by the VB.Net to C# Converter to support default instance behavour in C#
        /// </summary>
        public static Form1 Default
        {
            get
            {
                if (defaultInstance == null)
                {
                    defaultInstance = new Form1();
                    defaultInstance.FormClosed += new FormClosedEventHandler(defaultInstance_FormClosed);
                }

                return defaultInstance;
            }
            set
            {
                defaultInstance = value;
            }
        }

        static void defaultInstance_FormClosed(object sender, FormClosedEventArgs e)
        {
            defaultInstance = null;
        }

        #endregion
        public const int CHAN = 0;
        public int GraphMinnm; // min and max wavelength for graphic display of scan
        public int GraphMaxnm;
        public float[] amplitudes = new float[1025]; // storage for spectral scans and background scan
        public float[] background = new float[1025];
        public float[] Cmatrix = new float[1024 * 1024 + 1]; // stray light correction matrix (optional)
        public bool StrayLightCalLoaded = false;
        public float[] WLCal = new float[1025]; // wavelength calibration: pixel (0-LastPixel) in, wavelength (GraphMinnm-GraphMaxnm) out
        public float StartWL; // wavelength calibration: starting wavelength (pixel 0) and ending wavelength (LastPixel)
        public float EndWL;
        public bool WLCalLoaded = false; // wavelength calibration: a valid wavelength calibration was found in the RadOMA EEPROM
        public int[] PixelNum = new int[1201]; // wavelength calibration: wavelength in, pixel out (not used in this program)
        public string Units; // units string (uw/cm2, uw/cm2/sr)
        public StrTriStim TriStim = new StrTriStim(); // tristimulus structure
        public StrRadiometric Radiometric = new StrRadiometric(); // Radiometric analysis output structure
        public Strciexyz CIExyz = new Strciexyz(); // CIE 1931 x,y (,z?)
        public const int MAXDEFECTIVEPIXELS = 20;
        public int[] BadPixelLocation = new int[] { -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1 }; // assuming no defective pixels
        public StrGSDACQ GSDACQ = new StrGSDACQ(); // RadOMA data structure
        public StrSpectralFile AmpCal; // amplitude calibration structure
        public int LastPixel; // last pixel in the array, always 1023
        public t_RadiantFluxAnalysis RadiantAnalysis = new t_RadiantFluxAnalysis();
        public Struv u_v = new Struv();
        public static bool continuousScan = false;

        #region GSMath.dll
        [StructLayout(LayoutKind.Sequential)]
        public struct StrNA
        {
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 1024)]
            public float[] NewAmplitudes;
        }

        [StructLayout(LayoutKind.Sequential)]
        public struct StrTriStim
        {
            public float X;
            public float Y;
            public float Z;
        }

        [StructLayout(LayoutKind.Sequential)]
        public struct Strciexyz
        {
            public float x;
            public float y;
            public float z; //cie z
        }

        [StructLayout(LayoutKind.Sequential)]
        public struct Struv
        {
            public float u;
            public float v;
        }

        [StructLayout(LayoutKind.Sequential)]
        public struct StrRadiometric
        {
            public float radiance;
            public float irradiance;
            public float luminousFlux;
            public float photonFlux;
        }

        [StructLayout(LayoutKind.Sequential)]
        public struct StrLuminance
        {
            public float Nit;
            public float Stlib;
            public float Apostlib;
            public float Lambert;
            public float MilliLambert;
            public float FootLambert;
            public float Candela_persqrft;
            public float Candela_persqrin;
        }

        [StructLayout(LayoutKind.Sequential)]
        public struct StrColorimetric
        {
            public StrTriStim TristimulusXYZ1931;
            public StrTriStim TristimulusXYZ1964;
        }

        [StructLayout(LayoutKind.Sequential)]
        public struct t_RadiantFluxAnalysis
        {
            public float radiantFlux;
            public float photons;    // photons/sec

            public float luminousFlux_lumen;  // lm

            public typ_moments stats;
            public float peakWavelength;
            public float peakWavelengthCentroid;
            public float peakWavelengthPolyFit;
            public float peakWavelengthGaussian;
            public float peakWavelengthPoly2ndOrder;
            public float dominantWL;
            public Strciexyz dominantWLChromaticityXY;
            public float FWHM;

            // tristimulus are also part of colorimetric  
            public StrTriStim TristimulusXYZ1931;
            public StrTriStim TristimulusXYZ1964;
            public Strciexyz CIE1931_2deg;
            public Strciexyz CIE1931_10deg;
            public Struv CIE1960_UCS;
            public Struv CIE1976_UCS;
            public typ_Luv CIE1976_Luv_2deg;
            public typ_Luv CIE1976_Luv_10deg;
            public typ_Lab CIE1976_Lab_2deg;
            public typ_Lab CIE1976_Lab_10deg;
            public typ_CCTAnalysis CCT;
            public tCRI CRI;
            public float colorPurity;
        }

        [StructLayout(LayoutKind.Sequential)]
        public struct typ_CCTAnalysis
        {
          public float Kelvin;
          public float InverseMilliKelvin;
          public float MPCD;     // Mean perceivable color difference (MPCD)

          public float Duv;      // Distance from planckian surface (positive is above, negative below)
          public float Duv_u;
          public float Duv_v;
         } 

        [StructLayout(LayoutKind.Sequential)]
        public struct tCRI
        {
          [MarshalAs(UnmanagedType.ByValArray, SizeConst = 16)]
          public float[] R;
          public float Ra;
          [MarshalAs(UnmanagedType.ByValArray, SizeConst = 5)]
          public int[] warnings; 
        } 

        [StructLayout(LayoutKind.Sequential)]
        public struct typ_Luv
        {
          public float L_star;
          public float u_star;
          public float v_star;
        } 

        [StructLayout(LayoutKind.Sequential)]
        public struct typ_Lab
        {
          public float L_star;
          public float a_star;
          public float b_star;
        }

        // Spectral analysis functions (GSMath.dll)
        [DllImport("GSMath.dll", ExactSpelling = true, CharSet = CharSet.Auto, CallingConvention = CallingConvention.Cdecl, SetLastError = true)]
        public static extern int CalcTristimulusXYZ1931_2(float[] wavelengths, float[] amplitudes,int points, ref StrTriStim TriStim);
        [DllImport("GSMath.dll", ExactSpelling = true, CharSet = CharSet.Auto, CallingConvention = CallingConvention.Cdecl, SetLastError = true)]
        public static extern int TristimulusXYZToUCS1976uv(ref StrTriStim TriStim, ref Struv uv);
        [DllImport("GSMath.dll", ExactSpelling = true, CharSet = CharSet.Auto, CallingConvention = CallingConvention.Cdecl, SetLastError = true)]
        public static extern int TristimulusXYZTOCIE1931xyz(ref StrTriStim trisyz, ref Strciexyz ciexyz);
        [DllImport("GSMath.dll", ExactSpelling = true, CharSet = CharSet.Auto, CallingConvention = CallingConvention.Cdecl, SetLastError = true)]
        public static extern Single GetPeakWavelength2(float[] wavelengths, float[] data, int length, ref int index);
        [DllImport("GSMath.dll", ExactSpelling = true, CharSet = CharSet.Auto, CallingConvention = CallingConvention.Cdecl, SetLastError = true)]
        public static extern int DominantWavelength(ref Strciexyz stimulus, ref Strciexyz illuminant, ref Strciexyz domWLxycoord, ref float dominantWL);
        [DllImport("GSMath.dll", ExactSpelling = true, CharSet = CharSet.Auto, CallingConvention = CallingConvention.Cdecl, SetLastError = true)]
        public static extern int DominantWavelength2(ref Strciexyz stimulus, ref Strciexyz illuminant, ref Strciexyz domWLxycoord, ref float dominantWL);
        [DllImport("GSMath.dll", ExactSpelling = true, CharSet = CharSet.Auto, CallingConvention = CallingConvention.Cdecl, SetLastError = true)]
        public static extern int DominantWavelengthExtended(ref Strciexyz stimulus, ref Strciexyz illuminant, ref Strciexyz domWLxycoord, ref float dominantWL);
        [DllImport("GSMath.dll", ExactSpelling = true, CharSet = CharSet.Auto, CallingConvention = CallingConvention.Cdecl, SetLastError = true)]
        public static extern int RadiometryCalc2(float[] wavelengths, float[] SpectralWatts, int length, ref StrRadiometric Radiometric);
        [DllImport("GSMath.dll", ExactSpelling = true, CharSet = CharSet.Auto, CallingConvention = CallingConvention.Cdecl, SetLastError = true)]
        public static extern int LuminanceUnitsConvertAll(float fIncomingValue, int IncomingUnit, ref StrLuminance Luminance);
        [DllImport("GSMath.dll", ExactSpelling = true, CharSet = CharSet.Auto, CallingConvention = CallingConvention.Cdecl, SetLastError = true)]
        public static extern int ColorimetricCalc2(float[] wavelength, float[] SpectralWatts, int length, int standard_illuminant, float[] illuminantData, ref StrColorimetric Colorimetric);
        [DllImport("GSMath.dll", ExactSpelling = true, CharSet = CharSet.Auto, CallingConvention = CallingConvention.Cdecl, SetLastError = true)]
        public static extern double WavelengthForPixelFromPolyCal(ref StrSENSORCOEFFS_X polynomialCoefficients, int polynomialOrder, double pixel);
        [DllImport("GSMath.dll", ExactSpelling = true, CharSet = CharSet.Auto, CallingConvention = CallingConvention.Cdecl, SetLastError = true)]
        public static extern int Interpolate2(float[] wla, float[] ya, int lengtha, float[] wlb, ref StrNA yb, int lengthb);
        [DllImport("GSMath.dll", ExactSpelling = true, CharSet = CharSet.Auto, CallingConvention = CallingConvention.Cdecl, SetLastError = true)]
        public static extern int MatrixMultiplication(float[] Cmatrix, int rowsA, int colsA, float[] bMatrix, int rowsB, int colsB, ref StrNA cMatrix);
        [DllImport("GSMath.dll", ExactSpelling = true, CharSet = CharSet.Auto, CallingConvention = CallingConvention.Cdecl, SetLastError = true)]
        public static extern int SpectralAnalysis_RadiantFlux  (float[] wavelength,
                                             float[] data, 
                                             int length,
                                             int dwlwhichBar,
                                             ref Strciexyz dwlciexyz,
                                             int illuminantToApplyToCalc,
                                             float[] r15wavelength,
                                             float[] r15weights,
                                             int r15length,
                                             float[] r16wavelength,
                                             float[] r16weights,
                                             int r16length,
                                             ref t_RadiantFluxAnalysis analysisOut);

        #endregion

        #region GSUSB2SensorInterface.dll
        public struct StrSpectralFile
        {
            public string Units;
            public float StartWL; // = 0 means invalid/not loaded
            public float EndWL;
            public int Points;
            public float WLStep; // = 0 means variable step size, use Wavelengths()
            public float IT;
            public float[] Wavelengths;
            public float[] Amplitudes;
        }

        [StructLayout(LayoutKind.Sequential)]
        public struct StrHWSETTINGSTYPE_EXT
        {
            public int l_IF_type;
            public int l_IB_type;
            public int l_FEE_type;
            public int l_MUX_type;
            public int l_SENSOR_number;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 8)]
            public int[] l_SENSOR_type;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 8)]
            public int[] l_SENSOR_length;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 8)]
            public int[] l_SENSOR_rows;
        }
        [StructLayout(LayoutKind.Sequential)]
        public struct StrSENSORPARAMS_X
        {
            public int lSize;
            public StrSENSORCONFIG_X scfConfig;
            public int lReserved;
            public StrSENSORCOEFFS_X scoCoeffs;
        }
        [StructLayout(LayoutKind.Sequential)]
        public struct StrSENSORCONFIG_X
        {
            public short sSensorType;
            public short sSensorLength;
            public short sSensorBinAreas;
            public short sSensorPhysRows;
        }
        [StructLayout(LayoutKind.Sequential)]
        public struct StrSENSORCOEFFS_X
        {
            public double dC0;
            public double dC1;
            public double dC2;
            public double dC3;
            public double dC4;
        }

        [StructLayout(LayoutKind.Sequential)]
        public struct typ_moments
        {
            public float mean;
            public float averagedeviation;
            public float standarddeviation;
            public float variance;
            public float skewness;
            public float kurtosis;
        }
        [StructLayout(LayoutKind.Sequential)]
        public struct typ_arraystats_basic
        {
            public float min;
            public float max;
            public float mean;
        }

        [StructLayout(LayoutKind.Sequential)]
        public struct StrGSDACQ
        {
            public int OnLine;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 1)]
            public int[] Channel_ID;
            public int l_device;
            public int Averages;
            public int ArrayActiveLength;
            public double IntegrationTime_ms;
            public int WorkMode;
            public int Channels;
            public int TimeoutPC_milliseconds;
            public int DigitalInput1;
            public int DigitalInput2;
            public int DigitalInput3;
            public int DigitalOutput1;
            public int DigitalOutput2;
            public int DigitalOutput3;
            public StrHWSETTINGSTYPE_EXT HWSettings_Ext;
            public StrSENSORPARAMS_X spdata;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 2)]
            public double[] IntegrationTimeLimits_ms;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 2)]
            public int[] IntensityLimits_counts;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 2048)]
            public double[] PixelNumber;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 2048)]
            public double[] SpectralScanData;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 2048)]
            public double[] DarkCurrentData;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 1)]
            public typ_moments[] SpectralScanMoments;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 1)]
            public typ_arraystats_basic[] SpectralStats;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 1)]
            public typ_moments[] DarkCurrentMoments;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 1)]
            public typ_arraystats_basic[] DarkCurrentStats;
            public int ShutterLockedOpen;
        }

        // RadOMA control functions (GSUSB2SensorInterface.dll)
        [DllImport("GSUSB2SensorInterface.dll", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
        public static extern void GSDACQInitSettings();
        [DllImport("GSUSB2SensorInterface.dll", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
        public static extern int GSDACQOpenComm(int useDefaults);
        [DllImport("GSUSB2SensorInterface.dll", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
        public static extern int GSDACQCloseComm();
        [DllImport("GSUSB2SensorInterface.dll", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
        public static extern void GSDACQGetInternalSettings(int unit, ref StrGSDACQ sdacSettings);
        [DllImport("GSUSB2SensorInterface.dll", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
        public static extern int GSDACQGetHardwareSettings(int channelindex);
        [DllImport("GSUSB2SensorInterface.dll", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
        public static extern Single GSDACQSetIntegrationTime(float newexptime_ms);
        [DllImport("GSUSB2SensorInterface.dll", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
        public static extern int GSDACQSetWorkMode(int mode);
        [DllImport("GSUSB2SensorInterface.dll", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
        public static extern int GSDACQSetAverages(int averages);
        [DllImport("GSUSB2SensorInterface.dll", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
        public static extern int GSDACQSpectralScan(int shutterposition, int channelindex, int shutterOpenDelay_ms);
        [DllImport("GSUSB2SensorInterface.dll", EntryPoint = "_GSDACQMultiSpectralScan@16", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)] // ignores averages
        public static extern int GSDACQMultiSpectralScan(int shutterposition, int channelindex, int shutterOpenDelay_ms, int averages);
        [DllImport("GSUSB2SensorInterface.dll", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
        public static extern int GSDACQDarkCurrent(int cameraChannel, ref float[] darkCurrent, ref int nPts);
        [DllImport("GSUSB2SensorInterface.dll", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
        public static extern int GSDACQBackgroundScan(int delaytime_ms);
        [DllImport("GSUSB2SensorInterface.dll", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
        public static extern int GSDACQDarkCurrentCollectionMode(int allowDarkCorrection);
        [DllImport("GSUSB2SensorInterface.dll", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
        public static extern int GSDACQAutoIntegrationTime(ref float newintegrationtime, int shutterOpenDelay_ms);
        [DllImport("GSUSB2SensorInterface.dll", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
        public static extern int GSDACQAutoIntegrationTime2(float targetIntTime_ms, ref float newintegrationtime, int shutterOpenDelay_ms, int[] defectivePixelList);
        [DllImport("GSUSB2SensorInterface.dll", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
        public static extern int GSDACQAutoIntegrationTime3(float targetIntTime_ms, int targetCounts, int backgroundSubtract, int shutterOpenDelay_ms, int startPixel, int endPixel, int[] defectivePixelList, ref float newintegrationtime);
        [DllImport("GSUSB2SensorInterface.dll", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
        public static extern int GSDACQAutoIntegrationTime4(float targetIntTime_ms, int targetCounts, int backgroundSubtract, int shutterOpenDelay_ms, int startPixel, int endPixel, int[] defectivePixelList, ref float newintegrationtime);
        [DllImport("GSUSB2SensorInterface.dll", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
        public static extern void GSDACQShutterTogglePositionFlag();
        [DllImport("GSUSB2SensorInterface.dll", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
        public static extern int GSDACQGetShutterPosition();
        [DllImport("GSUSB2SensorInterface.dll", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
        public static extern int GSDACQShutter(int shutterposition);
        [DllImport("GSUSB2SensorInterface.dll", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
        public static extern int GSDACQFlagLockShutterOpen(int shutterLockOpen);
        [DllImport("GSUSB2SensorInterface.dll", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
        public static extern int GSDACQSetExternalTriggerTimeout(ref int value);
        [DllImport("GSUSB2SensorInterface.dll", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
        public static extern int GSDACQSetDigitalLine1(int value);
        [DllImport("GSUSB2SensorInterface.dll", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
        public static extern int GSDACQSetDigitalLine2(int value);
        [DllImport("GSUSB2SensorInterface.dll", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
        public static extern int GSDACQSetDigitalLine3(int value);
        [DllImport("GSUSB2SensorInterface.dll", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
        public static extern int GSDACQSetHardwareFlash2(int scanTrigger);
        [DllImport("GSUSB2SensorInterface.dll", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
        public static extern int GSDACQGetIntegrationTime(ref float currentIntTime_ms, ref float maxIntTime_ms, ref float minIntTime_ms);
        [DllImport("GSUSB2SensorInterface.dll", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
        public static extern int GSDACQCompleteScan2(int darkCurrentCorrection, int averages, int[] defectivePixelList);
        [DllImport("GSUSB2SensorInterface.dll", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
        public static extern int GSDACQCompleteScan3(int backgroundSubtract, int averages, int shutterOpenDelay_ms, int broadbandFilterWIdth, int bandlimitedFilterWidth, int boxCarWidth, int[] defectivePixelList, ref double minBkgndCounts, ref double maxBkgndCounts, ref double minScanCounts, ref double maxScanCounts);
        [DllImport("GSUSB2SensorInterface.dll", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
        public static extern int GSDACQGetArrayActiveLength();
        [DllImport("GSUSB2SensorInterface.dll", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
        public static extern int GSDACQGetDigitalOutput1();
        [DllImport("GSUSB2SensorInterface.dll", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
        public static extern int GSDACQGetDigitalOutput2();
        [DllImport("GSUSB2SensorInterface.dll", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
        public static extern int GSDACQGetDigitalOutput3();
        [DllImport("GSUSB2SensorInterface.dll", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
        public static extern void GSDACQSetTriggerMode(int mode);
        [DllImport("GSUSB2SensorInterface.dll", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
        public static extern int GSDACQGetErrorCode(ref int lastErrorCode);
        [DllImport("GSUSB2SensorInterface.dll", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
        public static extern void GSDACQSetActiveUnit(int unit);
        [DllImport("GSUSB2SensorInterface.dll", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
        public static extern int GSDACQOnLine();
        [DllImport("GSUSB2SensorInterface.dll", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
        public static extern int GSDACQSetDeviceID(int deviceID);
        [DllImport("GSUSB2SensorInterface.dll", ExactSpelling = true, CharSet = CharSet.Ansi, SetLastError = true)]
        public static extern int GSDACQGetWavelengthPolyCoefficients(double[] polyCoeff);

        #endregion

        public void BConnect_Click(System.Object sender, System.EventArgs e)
        {
            if (BConnect.Text == "Connect")
            {
                WLCalLoaded = false;
                GSDACQInitSettings();
                GSDACQSetActiveUnit(CHAN);
                GSDACQSetDeviceID((int)NUDRadOMAID.Value);

                int RadStat = GSDACQOpenComm(0);
                if (RadStat != 1)
                {
                    MessageBox.Show("Unable to open communications [" + System.Convert.ToString(RadStat) + "]");
                    return;
                }


                // Load the polynomial coefficients from the RadOMA EEPROM that define the wavelength calibration.
                // DC0 = constant, DC1 = linear coefficient, DC2 = square, DC3 = cube, DC4 = fourth power
                GSDACQGetHardwareSettings(CHAN);
                GSDACQGetInternalSettings(CHAN, ref GSDACQ);
                int PolyOrder = 4;
                
               if (GSDACQ.spdata.scoCoeffs.dC4 == 0)
                {
                    PolyOrder = 3;
                    if (GSDACQ.spdata.scoCoeffs.dC3 == 0)
                    {
                        PolyOrder = 2;
                        if (GSDACQ.spdata.scoCoeffs.dC2 == 0)
                        {
                            PolyOrder = 1;
                        }
                    }
                }

                // There at least needs to be a constant & linear term, otherwise we don't continue.
                if (GSDACQ.spdata.scoCoeffs.dC0 == 0 | GSDACQ.spdata.scoCoeffs.dC1 == 0)
                {
                    GSDACQCloseComm();
                    MessageBox.Show("Error: no wavelength calibration stored in RadOMA EEPROM.");
                    return;
                }
                
                // Fill WLCal() array with the wavelength of each pixel.
                LastPixel = (GSDACQGetArrayActiveLength() - 1);
                StartWL = (float)(WavelengthForPixelFromPolyCal(ref GSDACQ.spdata.scoCoeffs, PolyOrder, 0.0));

                for (int i = 0; i <= LastPixel; i++)
                {
                    WLCal[i] = (float)(WavelengthForPixelFromPolyCal(ref GSDACQ.spdata.scoCoeffs, PolyOrder, i));
                    EndWL = WLCal[i];
                }

                TBStartWL.Text = StartWL.ToString();
                TBEndWL.Text = EndWL.ToString();

                // Fill PixelNum() array with the pixel number of each wavelength. Not used by this program.
                for (int i = 0; i <= PixelNum.GetUpperBound(0); i++)
                {
                    // -1 means past the end of the detector array
                    PixelNum[i] = -1;
                }
                for (int i = 0; i <= LastPixel; i++)
                {
                    if (WLCal[i] != 0)
                    {
                        PixelNum[(int)(WLCal[i] + 0.5)] = i;
                    }
                }
                // Sanity check on wavelength calibration.
                if (float.IsInfinity(StartWL) || float.IsNaN(StartWL) || float.IsInfinity(EndWL) || float.IsNaN(EndWL) ||
                    StartWL < 300 | StartWL > 500 | EndWL < 750 | EndWL > 1200)
                {
                    GSDACQCloseComm();
                    MessageBox.Show("Error: invalid wavelength calibration stored in RadOMA EEPROM.");
                    return;
                }

                // Make the graphic plot start and end on nice integral multiples of 10 nm.
                GraphMinnm = (int)((Math.Max(AmpCal.StartWL, StartWL) / 10) * 10); // Use the higher of either the wavelength cal or the amplitude cal
                if (AmpCal.EndWL == 0) // if amplitude cal not present
                {
                    GraphMaxnm = (int)(Conversion.Int(EndWL / 10 + 1) * 10);
                }
                else
                {
                    GraphMaxnm = (int)(Conversion.Int((double)Math.Min((short)AmpCal.EndWL, (short)EndWL) / 10 + 1) * 10);
                }

                WLCalLoaded = true;
                BConnect.Text = "Disconnect";
            }
            else
            {
                BConnect.Text = "Connect";
                GSDACQCloseComm();
            }
        }

        public void BAutoIT_Click(System.Object sender, System.EventArgs e)
        {
            float IT = 0;
            int RadStat = 0;
            
            // This approach requires the use of the shutter.
            // Start at pixel 20 and end at 1021 as the beginning and end of the detector array shouldn't be used.
            // Auto-IT attempts to calculate the proper IT for the peak of the signal to be at 55,000 A/D counts.
            RadStat = GSDACQAutoIntegrationTime4(30, 
                                                55000,
                                                1, 
                                                (int)NUDShutterDelay.Value, 
                                                20, 
                                                1021, 
                                                BadPixelLocation, 
                                                ref IT);
            if (RadStat != 1)
            {
                MessageBox.Show("Error performing auto IT [" + RadStat.ToString() + "]");
                return;
            }

            IT = (float)(IT + 0.5);
            if (IT > (double)NUDIT.Maximum)
            {
                IT = (float)NUDIT.Maximum;
            }
            NUDIT.Value = (decimal)IT;
        }

        public void BBackgroundScan_Click(System.Object sender, System.EventArgs e)
        {
            int ScanResults = 0;

            ScanResults = (int)(GSDACQSetIntegrationTime((float)NUDIT.Value));
            if (ScanResults != NUDIT.Value)
            {
                MessageBox.Show("Unable to set integration time [" + System.Convert.ToString(ScanResults) + "]");
                return;
            }

            ScanResults = (int)(GSDACQSpectralScan(0, CHAN, (int)NUDShutterDelay.Value));
            if (ScanResults != 1)
            {
                MessageBox.Show("Error performing spectral scan [" + System.Convert.ToString(ScanResults) + "]");
                return;
            }

            GSDACQGetInternalSettings(CHAN, ref GSDACQ);
            for (int i = 0; i <= LastPixel; i++)
            {
                background[i] = (float)(GSDACQ.SpectralScanData[i]); // store scan in background() for later subtraction
            }
        }

        public void BScan_Click(System.Object sender, System.EventArgs e)
        {
            int ScanResults = 0;
            double minBackgroundCounts = 0;
            double maxBackgroundCounts = 0;
            double minScanCounts = 0;
            double maxScanCounts = 0;
            ScanResults = GSDACQCompleteScan3((CBCollectBackground.Checked ? 1 : 0),
                                                1,
                                                (int)(NUDShutterDelay.Value),
                                                0,
                                                0,
                                                0,
                                                null,
                                                ref minBackgroundCounts,
                                                ref maxBackgroundCounts,
                                                ref minScanCounts,
                                                ref maxScanCounts);
            if (ScanResults != 1)
            {
                MessageBox.Show("Error performing spectral scan [" + System.Convert.ToString(ScanResults) + "]");
                return;
            }

            GSDACQGetInternalSettings(CHAN, ref GSDACQ);
            for (int i = 0; i <= LastPixel; i++)
            {
                if (!CBCollectBackground.Checked)
                {
                    amplitudes[i] = (float)(GSDACQ.SpectralScanData[i] - background[i]); // subtract out the background scan
                }
                else
                {
                    amplitudes[i] = (float)(GSDACQ.SpectralScanData[i]);
                }
            }

            // if no calibration, just return counts
            if (AmpCal.StartWL == 0)
            {
                Units = "Counts";
            }
            else
            {
                // There is an amplitude calibration, so apply it & perform analysis
                Units = AmpCal.Units;

                // Apply calibration, scaling the results by the orignal IT during calibration vs. the IT used for this scan
                double ScaleFactor = AmpCal.IT / (float)NUDIT.Value;
                for (var i = 0; i <= LastPixel; i++)
                {
                    amplitudes[(int)i] *= (float)(ScaleFactor * AmpCal.Amplitudes[(int)i]);
                }

                // Perform & display analysis.
                int err;
                err = RadiometryCalc2(WLCal, amplitudes, LastPixel + 1, ref Radiometric);
                //example of error checking resulting from calculations
                if (err != 1)
                {
                    TBRadiometric.Text = "Error";
                    TBLumens.Text = "Error";
                }
                else
                {
                    TBRadiometric.Text = (Radiometric.irradiance).ToString();
                    TBLumens.Text = (Radiometric.luminousFlux).ToString();
                }

                CalcTristimulusXYZ1931_2(WLCal, amplitudes, LastPixel + 1, ref TriStim);
                TriStim.X *= (float)(6.83F);
                TriStim.Y *= (float)(6.83F);
                TriStim.Z *= 6.83F; // Add watts-per-lumen scaling factor so that Y shows photometric units (lm/m2, cd/m2)
                TBPhotometric.Text = System.Convert.ToString(TriStim.Y);
                TBXYZ.Text = TriStim.X + ", " + System.Convert.ToString(TriStim.Y) + ", " + System.Convert.ToString(TriStim.Z);
                TristimulusXYZTOCIE1931xyz(ref TriStim, ref CIExyz);

                err = SpectralAnalysis_RadiantFlux(WLCal,
                                                    amplitudes,
                                                    (LastPixel + 1),
                                                    0,
                                                    ref CIExyz,
                                                    0,
                                                    null,
                                                    null,
                                                    0,
                                                    null,
                                                    null,
                                                    0,
                                                    ref RadiantAnalysis);

                TBRadiantFlux.Text = (RadiantAnalysis.radiantFlux).ToString();
                TBCCT.Text = (RadiantAnalysis.CCT.Kelvin).ToString();
                TBCRI.Text = (RadiantAnalysis.CRI.Ra).ToString();


                err = TristimulusXYZToUCS1976uv(ref TriStim, ref u_v);
                TBUCSuv.Text = (u_v.u).ToString() + ", " + (u_v.v).ToString();

                TBxy.Text = CIExyz.x + ", " + System.Convert.ToString(CIExyz.y);
                int index = 0;
                TBPeakWL.Text = (GetPeakWavelength2(WLCal, amplitudes, LastPixel + 1, ref index)).ToString();
                Strciexyz Illuminantxy = new Strciexyz();
                Illuminantxy.x = 0.33333333F; // Illuminant E chromaticity (x,y) =  1/3rd, 1/3rd - - - put chromaticity of D65, A, etc. in here if you want D65, A, etc.
                Illuminantxy.y = (float)(0.33333333F);
                Strciexyz dominantWLxycoord = new Strciexyz();
                float dominantWL = 0;
                if (DominantWavelength2(ref CIExyz, ref Illuminantxy, ref dominantWLxycoord, ref dominantWL) == 1)
                {
                    TBDominantWL.Text = System.Convert.ToString(dominantWL);
                }
                else
                {
                    TBDominantWL.Text = "???";
                }
            }

            // Plot the scan on chart1.
            Chart1.ChartAreas[0].AxisX.Minimum = GraphMinnm;
            Chart1.ChartAreas[0].AxisX.Maximum = GraphMaxnm;
            Chart1.ChartAreas[0].AxisY.Minimum = 0;
            Chart1.ChartAreas[0].AxisX.Title = "nanometers";
            Chart1.ChartAreas[0].AxisY.Title = Units;

            Chart1.Series[0].Points.Clear();
            for (int i = 0; i <= LastPixel; i++)
            {
                Chart1.Series[0].Points.AddXY(Conversion.Int(WLCal[i] * 10) / 10, amplitudes[i]);
            }
            try
            {
                Chart1.ChartAreas[0].AxisX.RoundAxisValues();
                Chart1.Update();
            }
            catch (Exception)
            {
                Chart1.Series[0].Points.Clear();
                Chart1.Update();
            }
        }


        // load a Gamma Scientific Spectral File, 1.0- vs. 2.0-style differentiated by 1.0's wavelength step field (>10 implies 2.0-style)
        // returns   1 success
        //           0 failed, returns StartWL = 0
        // no [Integration Time] specified in the file returns IT = 0
        public int LoadGSpec(string filename, ref StrSpectralFile SpecData)
        {

            SpecData.StartWL = 0;
            SpecData.IT = 0;

            int FileNum = FileSystem.FreeFile();
            try
            {
                FileSystem.FileOpen(FileNum, filename, OpenMode.Input, (Microsoft.VisualBasic.OpenAccess)(-1), (Microsoft.VisualBasic.OpenShare)(-1), -1);
                FileSystem.LineInput(FileNum);
                FileSystem.LineInput(FileNum);
                SpecData.Units = FileSystem.LineInput(FileNum);
                int LinesOfText = System.Convert.ToInt32((FileSystem.LineInput(FileNum)));
                for (int i = 1; i <= LinesOfText; i++)
                {
                    string InString = FileSystem.LineInput(FileNum).ToUpper();
                    if (System.Convert.ToBoolean(InString.IndexOf("[INTEGRATION TIME]") + 1))
                    {
                        SpecData.IT = float.Parse(InString.Substring(0, InString.IndexOf(" ") + 0));
                    }
                }
                SpecData.StartWL = float.Parse(FileSystem.LineInput(1));
                SpecData.WLStep = float.Parse(FileSystem.LineInput(1));
                SpecData.EndWL = float.Parse(FileSystem.LineInput(1));
                if (SpecData.WLStep <= 10) // 1.0-style Gamma Spectral .csv file
                {
                    SpecData.Points = (int)((SpecData.EndWL - SpecData.StartWL) / SpecData.WLStep + 1);
                    SpecData.Wavelengths = new float[SpecData.Points];
                    SpecData.Amplitudes = new float[SpecData.Points];
                    for (int i = 0; i <= SpecData.Points - 1; i++)
                    {
                        SpecData.Amplitudes[i] = float.Parse(FileSystem.LineInput(FileNum));
                        SpecData.Wavelengths[i] = SpecData.StartWL + SpecData.WLStep * i;
                    }
                }
                else // 2.0-style
                {
                    SpecData.Points = (int)SpecData.WLStep;
                    SpecData.WLStep = 0;
                    SpecData.Wavelengths = new float[SpecData.Points];
                    SpecData.Amplitudes = new float[SpecData.Points];
                    for (int i = 0; i <= SpecData.Points - 1; i++)
                    {
                        string InString = FileSystem.LineInput(FileNum);
                        int cp = InString.IndexOf(",") + 1;
                        SpecData.Wavelengths[i] = float.Parse(InString.Substring(0, cp - 1));
                        SpecData.Amplitudes[i] = float.Parse(InString.Substring(cp));
                    }
                }

                FileSystem.FileClose(FileNum);
                return (1);

            }
            catch (Exception)
            {
                try
                {
                    FileSystem.FileClose(FileNum);
                }
                catch
                {
                }
                return (0);
            }
        }

        // Write a Gamma Scientific Spectral File, 2.0 format.
        public bool WriteGSpec(string FileName)
        {
            int FileNum = FileSystem.FreeFile();
            try
            {
                FileSystem.FileOpen(FileNum, FileName, OpenMode.Output, (Microsoft.VisualBasic.OpenAccess)(-1), (Microsoft.VisualBasic.OpenShare)(-1), -1);
                FileSystem.PrintLine(FileNum, "2.0 [Gamma Scientific Spectral File]");
                FileSystem.PrintLine(FileNum, "RadOMA dll DEMO Data File");
                FileSystem.PrintLine(FileNum, Units);

                FileSystem.PrintLine(FileNum, "2"); // Number of "info lines" to follow
                FileSystem.PrintLine(FileNum, DateAndTime.Now + " [Timestamp]");
                FileSystem.PrintLine(FileNum, NUDIT.Text + " [Integration Time]");
                FileSystem.PrintLine(FileNum, StartWL);
                FileSystem.PrintLine(FileNum, LastPixel + 1);
                FileSystem.PrintLine(FileNum, EndWL);
                for (int i = 0; i <= LastPixel; i++)
                {
                    FileSystem.PrintLine(FileNum, WLCal[i] + "," + System.Convert.ToString(amplitudes[i]));
                }
                FileSystem.FileClose(1);
            }
            catch (Exception)
            {
                try
                {
                    FileSystem.FileClose(1);
                }
                catch
                {
                }
                return false;
            }
            return true;
        }        

        public void BClearBackground_Click(System.Object sender, System.EventArgs e)
        {
            for (int i = 0; i <= LastPixel; i++)
            {
                background[i] = 0;
            }
        }

        public void BSaveScan_Click(System.Object sender, System.EventArgs e)
        {
            if (SFD.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                if (!WriteGSpec(SFD.FileName))
                {
                    MessageBox.Show("Unable to save scan file \"" + SFD.FileName + "\".");
                }
            }
        }

        public void BBrowse_Click(System.Object sender, System.EventArgs e)
        {
            if (OFD.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                if (LoadGSpec(OFD.FileName, ref AmpCal) != 1)
                {
                    MessageBox.Show("Unable to load Amplitude Calibration File \"" + OFD.FileName + "\"");
                }
                else
                {
                    TBAmpCalFilename.Text = OFD.FileName;
                    // Make the graphic plot start and end on nice integral multiples of 10 nm.
                    GraphMinnm = (int)(Conversion.Int((double)Math.Max((short)AmpCal.StartWL, (short)StartWL) / 10) * 10);
                    GraphMaxnm = System.Convert.ToInt32(System.Convert.ToInt32(Conversion.Int((double)Math.Min((short)AmpCal.EndWL, (short)EndWL) / 10 + 1)) * 10);
                }
            }
        }

        public void TBAmpCalFilename_TextChanged(System.Object sender, System.EventArgs e)
        {
            if (TBAmpCalFilename.Text == "")
            {
                AmpCal.StartWL = 0;
            }
        }

        public void Form1_Load(System.Object sender, System.EventArgs e)
        {
            // No cal file present means we operate in A/D counts only and don't perform any radiometric/photometric/colorimetric analysis of the results.
            if (TBAmpCalFilename.Text == "")
            {
                return;
            }
            if (LoadGSpec(TBAmpCalFilename.Text, ref AmpCal) != 1)
            {
                MessageBox.Show("Unable to load Amplitude Calibration File \"" + TBAmpCalFilename.Text + "\".");
                return;
            }
            else
            {
                GraphMinnm = (int)(Conversion.Int(AmpCal.StartWL / 10) * 10);
                GraphMaxnm = (int)(Conversion.Int(AmpCal.EndWL / 10 + 1) * 10);
            }
        }

        public void BScanContinuous_Click(System.Object sender, System.EventArgs e)
        {
            int ScanResults = 0;
            int ScanCounter = 0;
            double minBackgroundCounts = 0;
            double maxBackgroundCounts = 0;
            double minScanCounts = 0;
            double maxScanCounts = 0;

            if (!continuousScan)
            {
                continuousScan = true;
                BScanContinuous.Text = "Quit Scanning";
                ScanResults = (int)(GSDACQSetIntegrationTime((float)NUDIT.Value));
                if (ScanResults != NUDIT.Value)
                {
                    MessageBox.Show("Unable to set integration time [" + System.Convert.ToString(ScanResults) + "]");
                    return;
                }
            }
            else
            {
                continuousScan = false;
                BScanContinuous.Text = "Continuous Scan";
            }            
            
            while (continuousScan)
            {
                Application.DoEvents();
                ScanCounter++;

                ScanResults = GSDACQCompleteScan3((CBCollectBackground.Checked ? 1 : 0),
                                                    1,
                                                    (int)(NUDShutterDelay.Value),
                                                    0,
                                                    0,
                                                    0,
                                                    null,
                                                    ref minBackgroundCounts,
                                                    ref maxBackgroundCounts,
                                                    ref minScanCounts,
                                                    ref maxScanCounts);
                if (ScanResults != 1)
                {
                    MessageBox.Show("Error performing spectral scan [" + System.Convert.ToString(ScanResults) + "]");
                    return;
                }
                TBScanCount.Text = ScanCounter.ToString();
                TBScanCount.Update();
            }

        }

        private void NUDIT_ValueChanged(object sender, EventArgs e)
        {
            float setIT = 0;
            float IT = (float)(NUDIT.Value);
            setIT = GSDACQSetIntegrationTime(IT);
            if (setIT == 0)
            {
                MessageBox.Show("Error attempting to change integration time [" + setIT.ToString() + "]");
            }
            else
            {
                NUDIT.Value = (int)setIT;
            }
        }

        private void BReadWLCoefficients_Click(object sender, EventArgs e)
        {
            double[] polyCoefficients = new double[5];
            int result = GSDACQGetWavelengthPolyCoefficients(polyCoefficients);
            if (result != 1)
            {
                MessageBox.Show("Error attempting to read wavelength coefficients [" + result.ToString() + "]");
            }

            TBWLCoeff0.Text = polyCoefficients[0].ToString("e4");
            TBWLCoeff1.Text = polyCoefficients[1].ToString("e4");
            TBWLCoeff2.Text = polyCoefficients[2].ToString("e4");
            TBWLCoeff3.Text = polyCoefficients[3].ToString("e4");
            TBWLCoeff4.Text = polyCoefficients[4].ToString("e4");
        }
    }																																
}
