# GSRadomaClassLibrary.py
import sys
# this example uses pythonnet in order to use a C# dll (managed code) in python.  see https://pythonnet.github.io/
import clr
clr.AddReference("GSRadomaClassLibrary")
from GSRadomaClassLibrary import Radoma1290Class
from GSRadomaClassLibrary import RadomaDataClass
from GSRadomaClassLibrary import SpectralFileClass

def printData(prefix, data):
    print prefix + "() data.units=", data.AmpUnits
    print prefix + "() data.integrationMs=", data.integrationMs
    for i in range(0,data.iLength,256):
        print prefix + "[" + str(i) + "] ... " + str(data.Wavelengths[i]) + data.WaveUnits  + " = " + str(data.Amplitudes[i]) + " " + data.AmpUnits

# main
# initilization
gs1290 = Radoma1290Class()
gs1290.OpenComm()
gs1290.OpenShutter(True)
try:
    gs1290.calibration.LoadAmplitudeCalibration("nofile.cal") # RadianceCal.cal    nofile
except clr.System.Exception as e:
    print "error:", e
print "--------------------------------------------"
print "old IT:", gs1290.GetIntegrationTime()
#gs1290.SetIntegrationTime(50)
print "new IT:", gs1290.GetIntegrationTime()
gs1290.RunAutoIntegrationTime()
print "auto IT:", gs1290.GetIntegrationTime()
gs1290.OpenShutter(False)
background = gs1290.SimpleScan()
gs1290.OpenShutter(True)
foreground = gs1290.SimpleScan()
data = RadomaDataClass(foreground) # copy
data.Subtract(background)
for i in range(0,data.iLength,256):
    print "[" + str(i) + "] ... " + str(foreground.Amplitudes[i]) + " - " + str(background.Amplitudes[i]) + " = " + str(data.Amplitudes[i])      
printData("Before calibration", data)
data.ApplyWavelengthCalibration(gs1290.calibration.calWave)
data.ApplyAmplitudeCalibration(gs1290.calibration.calAmplitude)
printData("After  calibration", data)
sp = SpectralFileClass(data)
sp.WriteFile("spectra.csv")
gs1290.CloseComm()
